<template>
  <div class="flex flex-col h-screen max-w-md mx-auto justify-evenly">
    <div>
      <word-row
        v-for="(guess, i) in state.guesses"
        :key="i"
        :value="guess"
        :solution="state.solution"
        :submitted="i < state.currenGuessIndex"
      ></word-row>
    </div>

    <simple-keyboard @onKeyPress="handleInput" />
  </div>
</template>

<script setup>
import SimpleKeyboard from "./components/SimpleKeyboard.vue";
import WordRow from "./components/WordRow.vue";
import { reactive, onMounted } from "vue";

const state = reactive({
  solution: "books",
  guesses: ["", "", "", "", "", ""],
  currentGuessIndex: 0,
});

const handleInput = (key) => {
  if (state.currenGuessIndex >= 6) {
    return;
  }
  const currentGuess = state.guesses[state.currentGuessIndex];
  console.log("state.guesses", state.guesses);
  console.log("currentGuess", currentGuess);

  if (key == "{enter}") {
    // send guess
    if (currentGuess.length == 5) {
      state.currentGuessIndex++;
    }
  } else if (key == "{bksp}") {
    // remove last letter
    state.guesses[state.currentGuessIndex] = currentGuess.slice(0, -1);
  } else if (currentGuess.length < 5) {
    // add letter if alphabetical
    const alphaRegex = /[a-zA-Z]/;
    if (alphaRegex.test(key)) {
      state.guesses[state.currentGuessIndex] += key;
    }
  }
};

onMounted(() => {
  window.addEventListener("keyup", (e) => {
    e.preventDefault();
    let key =
      e.keyCode == 13
        ? "{enter}"
        : e.keyCode == 8
        ? "{bksp}"
        : String.fromCharCode(e.keyCode).toLocaleLowerCase();

    handleInput(key);
  });
});
</script>

<style></style>
